# coding: utf-8

"""
    Hangar API

    This page describes the format for the current Hangar REST API as well as general usage guidelines.<br> Note that all routes **not** listed here should be considered **internal**, and can change at a moment's notice. **Do not use them**.  ## Authentication and Authorization There are two ways to consume the API: Authenticated or anonymous.  ### Anonymous When using anonymous authentication, you only have access to public information, but you don't need to worry about creating and storing an API key or handing JWTs.  ### Authenticated If you need access to non-public content or actions, you need to create and use API keys. These can be created by going to the API keys page via the profile dropdown or by going to your user page and clicking on the key icon.  API keys allow you to impersonate yourself, so they should be handled like passwords. **Do not share them with anyone else!**  #### Getting and Using a JWT Once you have an API key, you need to authenticate yourself: Send a `POST` request with your API key identifier to `/api/v1/authenticate?apiKey=yourKey`. The response will contain your JWT as well as an expiration time. Put this JWT into the `Authorization` header of every request and make sure to request a new JWT after the expiration time has passed.  Please also set a meaningful `User-Agent` header. This allows us to better identify loads and needs for potentially new endpoints.  ## Misc ### Date Formats Standard ISO types. Where possible, we use the [OpenAPI format modifier](https://swagger.io/docs/specification/data-models/data-types/#format).  ### Rate Limits and Caching The default rate limit is set at 20 requests every 5 seconds with an initial overdraft for extra leniency. Individual endpoints, such as version creation, may have stricter rate limiting.  If applicable, always cache responses. The Hangar API itself is cached by CloudFlare and internally.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import unittest

from hangar_api.api.versions_api import VersionsApi


class TestVersionsApi(unittest.TestCase):
    """VersionsApi unit test stubs"""

    def setUp(self) -> None:
        self.api = VersionsApi()

    def tearDown(self) -> None:
        pass

    def test_download_version(self) -> None:
        """Test case for download_version

        Downloads a version
        """
        pass

    def test_download_version1(self) -> None:
        """Test case for download_version1

        """
        pass

    def test_get_latest_release_version(self) -> None:
        """Test case for get_latest_release_version

        """
        pass

    def test_get_latest_version(self) -> None:
        """Test case for get_latest_version

        """
        pass

    def test_get_version(self) -> None:
        """Test case for get_version

        """
        pass

    def test_get_version_stats(self) -> None:
        """Test case for get_version_stats

        """
        pass

    def test_get_versions(self) -> None:
        """Test case for get_versions

        """
        pass

    def test_latest_release_version(self) -> None:
        """Test case for latest_release_version

        Returns the latest release version of a project
        """
        pass

    def test_latest_version(self) -> None:
        """Test case for latest_version

        Returns the latest version of a project for a specific channel
        """
        pass

    def test_list_versions(self) -> None:
        """Test case for list_versions

        Returns all versions of a project
        """
        pass

    def test_show_version(self) -> None:
        """Test case for show_version

        Returns a specific version of a project
        """
        pass

    def test_show_version_stats(self) -> None:
        """Test case for show_version_stats

        Returns the stats for a version
        """
        pass

    def test_upload_version(self) -> None:
        """Test case for upload_version

        Creates a new version and returns parts of its metadata
        """
        pass

    def test_upload_version1(self) -> None:
        """Test case for upload_version1

        """
        pass


if __name__ == '__main__':
    unittest.main()
